diff -ruN vdr-1.7.0/device.h vdr-1.7.1/device.h
--- vdr-1.7.0/device.h	2008-04-12 13:11:23.000000000 +0200
+++ vdr-1.7.1/device.h	2008-07-06 13:25:42.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.1 2008/04/12 11:11:23 kls Exp $
+ * $Id: device.h 2.2 2008/07/06 11:25:42 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -17,6 +17,7 @@
 #include "filter.h"
 #include "nit.h"
 #include "pat.h"
+#include "remux.h"
 #include "ringbuffer.h"
 #include "sdt.h"
 #include "sections.h"
@@ -30,10 +31,6 @@
 #define MAXVOLUME         255
 #define VOLUMEDELTA         5 // used to increase/decrease the volume
 
-#define TS_SIZE          188
-#define TS_SYNC_BYTE     0x47
-#define PID_MASK_HI      0x1F
-
 enum eSetChannelResult { scrOk, scrNotAvailable, scrNoTransfer, scrFailed };
 
 enum ePlayMode { pmNone,           // audio/video from decoder
@@ -89,7 +86,6 @@
 
 class cPlayer;
 class cReceiver;
-class cPesAssembler;
 class cLiveSubtitle;
 
 /// The cDevice class is the base from which actual devices can be derived.
@@ -477,7 +473,10 @@
 
 private:
   cPlayer *player;
-  cPesAssembler *pesAssembler;
+  cPatPmtParser patPmtParser;
+  cTsToPes tsToPesVideo;
+  cTsToPes tsToPesAudio;
+  cTsToPes tsToPesSubtitle;
 protected:
   virtual bool CanReplay(void) const;
        ///< Returns true if this device can currently start a replay session.
@@ -511,6 +510,33 @@
        ///< If VideoOnly is true, only the video will be displayed,
        ///< which is necessary for trick modes like 'fast forward'.
        ///< Data must point to one single, complete PES packet.
+  virtual int PlayTsVideo(const uchar *Data, int Length);
+       ///< Plays the given data block as video.
+       ///< Data points to exactly one complete TS packet of the given Length
+       ///< (which is always TS_SIZE).
+       ///< PlayTsVideo() shall process the packet either as a whole (returning
+       ///< a positive number, which needs not necessarily be Length) or not at all
+       ///< (returning 0 or -1 and setting 'errno' to EAGAIN).
+       ///< The default implementation collects all incoming TS payload belonging
+       ///< to one PES packet and calls PlayVideo() with the resulting packet.
+  virtual int PlayTsAudio(const uchar *Data, int Length);
+       ///< Plays the given data block as audio.
+       ///< Data points to exactly one complete TS packet of the given Length
+       ///< (which is always TS_SIZE).
+       ///< PlayTsAudio() shall process the packet either as a whole (returning
+       ///< a positive number, which needs not necessarily be Length) or not at all
+       ///< (returning 0 or -1 and setting 'errno' to EAGAIN).
+       ///< The default implementation collects all incoming TS payload belonging
+       ///< to one PES packet and calls PlayAudio() with the resulting packet.
+  virtual int PlayTsSubtitle(const uchar *Data, int Length);
+       ///< Plays the given data block as a subtitle.
+       ///< Data points to exactly one complete TS packet of the given Length
+       ///< (which is always TS_SIZE).
+       ///< PlayTsSubtitle() shall process the packet either as a whole (returning
+       ///< a positive number, which needs not necessarily be Length) or not at all
+       ///< (returning 0 or -1 and setting 'errno' to EAGAIN).
+       ///< The default implementation collects all incoming TS payload belonging
+       ///< to one PES packet and displays the resulting subtitle via the OSD.
 public:
   virtual int64_t GetSTC(void);
        ///< Gets the current System Time Counter, which can be used to
@@ -565,6 +591,21 @@
        ///< to a complete packet with data from the next call to PlayPes().
        ///< That way any functions called from within PlayPes() will be
        ///< guaranteed to always receive complete PES packets.
+  virtual int PlayTs(const uchar *Data, int Length, bool VideoOnly = false);
+       ///< Plays the given TS packet.
+       ///< If VideoOnly is true, only the video will be displayed,
+       ///< which is necessary for trick modes like 'fast forward'.
+       ///< Data points to a single TS packet, Length is always TS_SIZE (the total
+       ///< size of a single TS packet).
+       ///< A derived device can reimplement this function to handle the
+       ///< TS packets itself. Any packets the derived function can't handle
+       ///< must be sent to the base class function. This applies especially
+       ///< to the PAT/PMT packets.
+       ///< Returns -1 in case of error, otherwise the number of actually
+       ///< processed bytes is returned, which may be less than Length.
+       ///< PlayTs() shall process the packet either as a whole (returning
+       ///< a positive number, which needs not necessarily be Length) or not at all
+       ///< (returning 0 or -1 and setting 'errno' to EAGAIN).
   bool Replaying(void) const;
        ///< Returns true if we are currently replaying.
   bool Transferring(void) const;
diff -ruN vdr-1.7.0/dvbdevice.c vdr-1.7.1/dvbdevice.c
--- vdr-1.7.0/dvbdevice.c	2008-04-13 16:15:35.000000000 +0200
+++ vdr-1.7.1/dvbdevice.c	2008-07-06 15:58:56.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 2.2 2008/04/13 14:15:35 kls Exp $
+ * $Id: dvbdevice.c 2.4 2008/07/06 13:58:56 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -266,10 +266,6 @@
 
      tuneTimeout = DVBS_TUNE_TIMEOUT;
      lockTimeout = DVBS_LOCK_TIMEOUT;
-
-     dvbfe_info feinfo;
-     feinfo.delivery = Frontend.delivery;
-     CHECK(ioctl(fd_frontend, DVBFE_GET_INFO, &feinfo)); //switch system
      }
   else if (frontendType & DVBFE_DELSYS_DVBC) {
      Frontend.delivery = DVBFE_DELSYS_DVBC;
@@ -281,10 +277,6 @@
 
      tuneTimeout = DVBC_TUNE_TIMEOUT;
      lockTimeout = DVBC_LOCK_TIMEOUT;
-
-     dvbfe_info feinfo;
-     feinfo.delivery = Frontend.delivery;
-     CHECK(ioctl(fd_frontend, DVBFE_GET_INFO, &feinfo)); //switch system
      }
   else if (frontendType & DVBFE_DELSYS_DVBT) {
      Frontend.delivery = DVBFE_DELSYS_DVBT;
@@ -302,15 +294,12 @@
 
      tuneTimeout = DVBT_TUNE_TIMEOUT;
      lockTimeout = DVBT_LOCK_TIMEOUT;
-
-     dvbfe_info feinfo;
-     feinfo.delivery = Frontend.delivery;
-     CHECK(ioctl(fd_frontend, DVBFE_GET_INFO, &feinfo)); //switch system
      }
   else {
      esyslog("ERROR: attempt to set channel with unknown DVB frontend type");
      return false;
      }
+  CHECK(ioctl(fd_frontend, DVBFE_SET_DELSYS, &Frontend.delivery));
   if (ioctl(fd_frontend, DVBFE_SET_PARAMS, &Frontend) < 0) {
      esyslog("ERROR: frontend %d: %m", cardIndex);
      return false;
@@ -1247,6 +1236,18 @@
   return WriteAllOrNothing(fd_audio, Data, Length, 1000, 10);
 }
 
+int cDvbDevice::PlayTsVideo(const uchar *Data, int Length)
+{
+  Length = TsGetPayload(&Data);
+  return PlayVideo(Data, Length);
+}
+
+int cDvbDevice::PlayTsAudio(const uchar *Data, int Length)
+{
+  Length = TsGetPayload(&Data);
+  return PlayAudio(Data, Length, 0);
+}
+
 bool cDvbDevice::OpenDvr(void)
 {
   CloseDvr();
diff -ruN vdr-1.7.0/dvbdevice.h vdr-1.7.1/dvbdevice.h
--- vdr-1.7.0/dvbdevice.h	2008-04-12 13:20:48.000000000 +0200
+++ vdr-1.7.1/dvbdevice.h	2008-06-01 11:48:04.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.h 2.1 2008/04/12 11:20:48 kls Exp $
+ * $Id: dvbdevice.h 2.2 2008/06/01 09:48:04 kls Exp $
  */
 
 #ifndef __DVBDEVICE_H
@@ -138,6 +138,8 @@
   virtual bool SetPlayMode(ePlayMode PlayMode);
   virtual int PlayVideo(const uchar *Data, int Length);
   virtual int PlayAudio(const uchar *Data, int Length, uchar Id);
+  virtual int PlayTsVideo(const uchar *Data, int Length);
+  virtual int PlayTsAudio(const uchar *Data, int Length);
 public:
   virtual int64_t GetSTC(void);
   virtual void TrickSpeed(int Speed);
diff -ruN vdr-1.7.0/dvbsubtitle.c vdr-1.7.1/dvbsubtitle.c
--- vdr-1.7.0/dvbsubtitle.c	2007-11-25 14:33:08.000000000 +0100
+++ vdr-1.7.1/dvbsubtitle.c	2008-05-25 16:36:24.000000000 +0200
@@ -7,7 +7,7 @@
  * Original author: Marco Schlüßler <marco@lordzodiac.de>
  * With some input from the "subtitle plugin" by Pekka Virtanen <pekka.virtanen@sci.fi>
  *
- * $Id: dvbsubtitle.c 2.0 2007/11/25 13:33:08 kls Exp $
+ * $Id: dvbsubtitle.c 2.1 2008/05/25 14:36:24 kls Exp $
  */
 
 #include "dvbsubtitle.h"
@@ -580,12 +580,12 @@
 unsigned char *cDvbSubtitleAssembler::Get(int &Length)
 {
   if (length > pos + 5) {
-      Length = (data[pos + 4] << 8) + data[pos + 5] + 6;
-      if (length >= pos + Length) {
-         unsigned char *result = data + pos;
-         pos += Length;
-         return result;
-         }
+     Length = (data[pos + 4] << 8) + data[pos + 5] + 6;
+     if (length >= pos + Length) {
+        unsigned char *result = data + pos;
+        pos += Length;
+        return result;
+        }
      }
   return NULL;
 }
@@ -684,10 +684,10 @@
   Unlock();
 }
 
-int cDvbSubtitleConverter::Convert(const uchar *Data, int Length)
+int cDvbSubtitleConverter::ConvertFragments(const uchar *Data, int Length)
 {
   if (Data && Length > 8) {
-     int PayloadOffset = Data[8] + 9;
+     int PayloadOffset = PesPayloadOffset(Data);
      int SubstreamHeaderLength = 4;
      bool ResetSubtitleAssembler = Data[PayloadOffset + 3] == 0x00;
 
@@ -699,15 +699,9 @@
         }
 
      if (Length > PayloadOffset + SubstreamHeaderLength) {
-        int64_t pts = 0;
-        if ((Data[7] & 0x80) && Data[8] >= 5) {
-           pts  = (((int64_t)Data[ 9]) & 0x0E) << 29;
-           pts |= ( (int64_t)Data[10])         << 22;
-           pts |= (((int64_t)Data[11]) & 0xFE) << 14;
-           pts |= ( (int64_t)Data[12])         <<  7;
-           pts |= (((int64_t)Data[13]) & 0xFE) >>  1;
+        int64_t pts = PesGetPts(Data);
+        if (pts)
            dbgconverter("Converter PTS: %lld\n", pts);
-           }
         const uchar *data = Data + PayloadOffset + SubstreamHeaderLength; // skip substream header
         int length = Length - PayloadOffset - SubstreamHeaderLength; // skip substream header
         if (ResetSubtitleAssembler)
@@ -728,6 +722,40 @@
                     }
                  else
                     break;
+                 }
+           }
+        }
+     return Length;
+     }
+  return 0;
+}
+
+int cDvbSubtitleConverter::Convert(const uchar *Data, int Length)
+{
+  if (Data && Length > 8) {
+     int PayloadOffset = PesPayloadOffset(Data);
+     if (Length > PayloadOffset) {
+        int64_t pts = PesGetPts(Data);
+        if (pts)
+           dbgconverter("Converter PTS: %lld\n", pts);
+        const uchar *data = Data + PayloadOffset;
+        int length = Length - PayloadOffset;
+        if (length > 3) {
+           if (data[0] == 0x20 && data[1] == 0x00 && data[2] == 0x0F) {
+              data += 2;
+              length -= 2;
+              }
+           const uchar *b = data;
+           while (length > 0) {
+                 if (b[0] == 0x0F) {
+                    int n = ExtractSegment(b, length, pts);
+                    if (n < 0)
+                       break;
+                    b += n;
+                    length -= n;
+                    }
+                 else
+                    break;
                  }
            }
         }
diff -ruN vdr-1.7.0/dvbsubtitle.h vdr-1.7.1/dvbsubtitle.h
--- vdr-1.7.0/dvbsubtitle.h	2007-10-14 16:02:46.000000000 +0200
+++ vdr-1.7.1/dvbsubtitle.h	2008-05-25 16:36:52.000000000 +0200
@@ -6,7 +6,7 @@
  *
  * Original author: Marco Schlüßler <marco@lordzodiac.de>
  *
- * $Id: dvbsubtitle.h 2.0 2007/10/14 14:02:46 kls Exp $
+ * $Id: dvbsubtitle.h 2.1 2008/05/25 14:36:52 kls Exp $
  */
 
 #ifndef __DVBSUBTITLE_H
@@ -17,7 +17,7 @@
 #include "tools.h"
 
 class cDvbSubtitlePage;
-class cDvbSubtitleAssembler;
+class cDvbSubtitleAssembler; // for legacy PES recordings
 class cDvbSubtitleBitmaps;
 
 class cDvbSubtitleConverter : public cThread {
@@ -36,6 +36,7 @@
   virtual ~cDvbSubtitleConverter();
   void Action(void);
   void Reset(void);
+  int ConvertFragments(const uchar *Data, int Length); // for legacy PES recordings
   int Convert(const uchar *Data, int Length);
   static void SetupChanged(void);
   };
diff -ruN vdr-1.7.0/eit.c vdr-1.7.1/eit.c
--- vdr-1.7.0/eit.c	2008-04-13 13:27:06.000000000 +0200
+++ vdr-1.7.1/eit.c	2008-05-01 17:33:27.000000000 +0200
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 2.1 2008/04/13 11:27:06 kls Exp $
+ * $Id: eit.c 2.2 2008/05/01 15:33:27 kls Exp $
  */
 
 #include "eit.h"
@@ -219,7 +219,7 @@
                  SI::ComponentDescriptor *cd = (SI::ComponentDescriptor *)d;
                  uchar Stream = cd->getStreamContent();
                  uchar Type = cd->getComponentType();
-                 if (1 <= Stream && Stream <= 3 && Type != 0) { // 1=video, 2=audio, 3=subtitles
+                 if (1 <= Stream && Stream <= 4 && Type != 0) { // 1=video, 2=audio, 3=subtitles, 4=AC3
                     if (!Components)
                        Components = new cComponents;
                     char buffer[Utf8BufSize(256)];
diff -ruN vdr-1.7.0/epg.c vdr-1.7.1/epg.c
--- vdr-1.7.0/epg.c	2008-02-16 17:09:12.000000000 +0100
+++ vdr-1.7.1/epg.c	2008-05-01 16:53:55.000000000 +0200
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 2.0 2008/02/16 16:09:12 kls Exp $
+ * $Id: epg.c 2.1 2008/05/01 14:53:55 kls Exp $
  */
 
 #include "epg.h"
@@ -88,8 +88,10 @@
 tComponent *cComponents::GetComponent(int Index, uchar Stream, uchar Type)
 {
   for (int i = 0; i < numComponents; i++) {
-      // In case of an audio stream the 'type' check actually just distinguishes between "normal" and "Dolby Digital":
-      if (components[i].stream == Stream && (Stream != 2 || (components[i].type < 5) == (Type < 5))) {
+      if (components[i].stream == Stream && (
+          Type == 0 || // don't care about the actual Type
+          Stream == 2 && (components[i].type < 5) == (Type < 5) // fallback "Dolby" component according to the "Premiere pseudo standard"
+         )) {
          if (!Index--)
             return &components[i];
          }
diff -ruN vdr-1.7.0/font.c vdr-1.7.1/font.c
--- vdr-1.7.0/font.c	2008-03-01 11:19:41.000000000 +0100
+++ vdr-1.7.1/font.c	2008-05-02 18:16:51.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: font.c 2.0 2008/03/01 10:19:41 kls Exp $
+ * $Id: font.c 2.1 2008/05/02 16:16:51 kls Exp $
  */
 
 #include "font.h"
@@ -395,7 +395,7 @@
      FcFontSetDestroy(fontset);
      FcPatternDestroy(pat);
      FcObjectSetDestroy(os);
-     FcFini();
+     //FcFini(); // older versions of fontconfig are broken - and FcInit() can be called more than once
      FontNames->Sort();
      }
   return FontNames->Size() > 0;
@@ -431,7 +431,7 @@
         esyslog("ERROR: no usable font found for '%s'", FontName);
      FcPatternDestroy(pat);
      free(fn);
-     FcFini();
+     //FcFini(); // older versions of fontconfig are broken - and FcInit() can be called more than once
      }
   return FontFileName;
 }
diff -ruN vdr-1.7.0/i18n.c vdr-1.7.1/i18n.c
--- vdr-1.7.0/i18n.c	2008-01-19 13:07:11.000000000 +0100
+++ vdr-1.7.1/i18n.c	2008-09-06 14:24:43.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: i18n.c 2.0 2008/01/19 12:07:11 kls Exp $
+ * $Id: i18n.c 2.1 2008/09/06 12:24:43 kls Exp $
  *
  *
  */
@@ -45,7 +45,7 @@
   "por",
   "fra,fre",
   "nor",
-  "fin,smi",
+  "fin,suo",
   "pol",
   "esl,spa",
   "ell,gre",
diff -ruN vdr-1.7.0/libsi/si.h vdr-1.7.1/libsi/si.h
--- vdr-1.7.0/libsi/si.h	2007-04-22 15:32:09.000000000 +0200
+++ vdr-1.7.1/libsi/si.h	2008-09-06 14:44:06.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.h 2.0 2007/04/22 13:32:09 kls Exp $
+ *   $Id: si.h 2.1 2008/09/06 12:44:06 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -28,7 +28,7 @@
                TableIdNIT_other  = 0x41, //network information section, other network
                TableIdSDT = 0x42, //service description section
                TableIdSDT_other  = 0x46,
-               TableIdBAT = 0x46, //bouquet association section
+               TableIdBAT = 0x4A, //bouquet association section
                TableIdEIT_presentFollowing = 0x4E, //event information section
                TableIdEIT_presentFollowing_other = 0x4F,
                //range from 0x50 to 0x5F
diff -ruN vdr-1.7.0/libsi/util.h vdr-1.7.1/libsi/util.h
--- vdr-1.7.0/libsi/util.h	2006-02-25 11:13:28.000000000 +0100
+++ vdr-1.7.1/libsi/util.h	2008-05-22 12:49:08.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: util.h 2.0 2006/02/25 10:13:28 kls Exp $
+ *   $Id: util.h 2.1 2008/05/22 10:49:08 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -148,9 +148,9 @@
    CRC32(const char *d, int len, u_int32_t CRCvalue=0xFFFFFFFF);
    bool isValid() { return crc32(data, length, value) == 0; }
    static bool isValid(const char *d, int len, u_int32_t CRCvalue=0xFFFFFFFF) { return crc32(d, len, CRCvalue) == 0; }
+   static u_int32_t crc32(const char *d, int len, u_int32_t CRCvalue);
 protected:
    static u_int32_t crc_table[256];
-   static u_int32_t crc32 (const char *d, int len, u_int32_t CRCvalue);
 
    const char *data;
    int length;
diff -ruN vdr-1.7.0/menu.c vdr-1.7.1/menu.c
--- vdr-1.7.0/menu.c	2008-04-12 13:37:17.000000000 +0200
+++ vdr-1.7.1/menu.c	2008-05-01 16:37:24.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 2.1 2008/04/12 11:37:17 kls Exp $
+ * $Id: menu.c 2.2 2008/05/01 14:37:24 kls Exp $
  */
 
 #include "menu.h"
@@ -3147,6 +3147,8 @@
                    break;
            case 3: cDevice::PrimaryDevice()->SetAvailableTrack(ttSubtitle, indexSubtitle++, 0, LiveChannel ? NULL : p->language, p->description);
                    break;
+           case 4: cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, indexDolby++, 0, LiveChannel ? NULL : p->language, p->description);
+                   break;
            }
          }
      }
diff -ruN vdr-1.7.0/pat.c vdr-1.7.1/pat.c
--- vdr-1.7.0/pat.c	2008-04-12 15:34:50.000000000 +0200
+++ vdr-1.7.1/pat.c	2008-07-06 16:01:32.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: pat.c 2.1 2008/04/12 13:34:50 kls Exp $
+ * $Id: pat.c 2.2 2008/07/06 14:01:32 kls Exp $
  */
 
 #include "pat.h"
@@ -328,7 +328,8 @@
         // Scan the stream-specific loop:
         SI::PMT::Stream stream;
         int Vpid = 0;
-        int Ppid = pmt.getPCRPid();
+        int Ppid = 0;
+        int Vtype = 0;
         int Apids[MAXAPIDS + 1] = { 0 }; // these lists are zero-terminated
         int Dpids[MAXDPIDS + 1] = { 0 };
         int Spids[MAXSPIDS + 1] = { 0 };
@@ -343,8 +344,10 @@
             switch (stream.getStreamType()) {
               case 1: // STREAMTYPE_11172_VIDEO
               case 2: // STREAMTYPE_13818_VIDEO
-//TODO        case 0x1B: // MPEG4
+              case 0x1B: // MPEG4
                       Vpid = stream.getPid();
+                      Ppid = pmt.getPCRPid();
+                      Vtype = stream.getStreamType();
                       break;
               case 3: // STREAMTYPE_11172_AUDIO
               case 4: // STREAMTYPE_13818_AUDIO
@@ -440,7 +443,7 @@
                 }
             }
         if (Setup.UpdateChannels >= 2) {
-           Channel->SetPids(Vpid, Vpid ? Ppid : 0, Apids, ALangs, Dpids, DLangs, Spids, SLangs, Tpid);
+           Channel->SetPids(Vpid, Ppid, Vtype, Apids, ALangs, Dpids, DLangs, Spids, SLangs, Tpid);
            Channel->SetCaIds(CaDescriptors->CaIds());
            }
         Channel->SetCaDescriptors(CaDescriptorHandler.AddCaDescriptors(CaDescriptors));
diff -ruN vdr-1.7.0/player.h vdr-1.7.1/player.h
--- vdr-1.7.0/player.h	2008-02-16 14:50:11.000000000 +0100
+++ vdr-1.7.1/player.h	2008-08-15 16:07:48.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: player.h 2.0 2008/02/16 13:50:11 kls Exp $
+ * $Id: player.h 2.1 2008/08/15 14:07:48 kls Exp $
  */
 
 #ifndef __PLAYER_H
@@ -42,6 +42,10 @@
        // Sends the given PES Data to the device and returns the number of
        // bytes that have actually been accepted by the device (or a
        // negative value in case of an error).
+  int PlayTs(const uchar *Data, int Length, bool VideoOnly = false) { return device ? device->PlayTs(Data, Length, VideoOnly) : -1; }
+       // Sends the given TS packet to the device and returns a positive number
+       // if the packet has been accepted by the device, or a negative value in
+       // case of an error.
 public:
   cPlayer(ePlayMode PlayMode = pmAudioVideo);
   virtual ~cPlayer();
diff -ruN vdr-1.7.0/recording.c vdr-1.7.1/recording.c
--- vdr-1.7.0/recording.c	2008-02-24 11:28:53.000000000 +0100
+++ vdr-1.7.1/recording.c	2008-06-12 23:46:08.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.0 2008/02/24 10:28:53 kls Exp $
+ * $Id: recording.c 2.3 2008/06/12 21:46:08 kls Exp $
  */
 
 #include "recording.h"
@@ -31,8 +31,8 @@
 /* This was the original code, which works fine in a Linux only environment.
    Unfortunately, because of Windows and its brain dead file system, we have
    to use a more complicated approach, in order to allow users who have enabled
-   the VFAT compile time option to see their recordings even if they forget to
-   enable VFAT when compiling a new version of VDR... Gee, do I hate Windows.
+   the --vfat command line option to see their recordings even if they forget to
+   enable --vfat when restarting VDR... Gee, do I hate Windows.
    (kls 2002-07-27)
 #define DATAFORMAT   "%4d-%02d-%02d.%02d:%02d.%02d.%02d" RECEXT
 #define NAMEFORMAT   "%s/%s/" DATAFORMAT
@@ -297,7 +297,9 @@
      for (int i = 0; i < MAXDPIDS; i++) {
          const char *s = Channel->Dlang(i);
          if (*s) {
-            tComponent *Component = Components->GetComponent(i, 2, 5);
+            tComponent *Component = Components->GetComponent(i, 4, 0); // AC3 component according to the DVB standard
+            if (!Component)
+               Component = Components->GetComponent(i, 2, 5); // fallback "Dolby" component according to the "Premiere pseudo standard"
             if (!Component)
                Components->SetComponent(Components->NumComponents(), 2, 5, s, NULL);
             else if (strlen(s) > strlen(Component->language))
@@ -1483,8 +1485,8 @@
                  return SetOffset(Number + 1); // file exists and has non zero size, let's try next suffix
               else {
                  // zero size file, remove it
-                 dsyslog ("cFileName::SetOffset: removing zero-sized file %s", fileName);
-                 unlink (fileName);
+                 dsyslog("cFileName::SetOffset: removing zero-sized file %s", fileName);
+                 unlink(fileName);
                  }
               }
            else
